<?php
/**
 * @package Gratisfaction AppsMav
 * @version 3.4.1
 */
/*
 Plugin Name: Gratisfaction Rewards
 Plugin URI: http://appsmav.com
 Description: Gratisfaction Loyalty Giveaways Rewards and Referral Program.
 Version: 3.4.1
 Author: AppsMav
 Author URI: http://appsmav.com
 License: GPL2
*/
/*  Copyright 2015  Appsmav  (email : support@appsmav.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
define('GR_WP_PLUGIN_BASE_PATH', dirname(__FILE__));

if(!class_exists('GR_Appsmav'))
{
    class GR_Appsmav
    {
        protected static $_callback_url = 'https://gratisfaction.appsmav.com/';
        protected static $_api_version  = 'newapi/v2/';
        protected static $_api_url      = 'https://clients.appsmav.com/api_v1.php';
        protected static $_c_sdk_url    = '//cdn.appsmav.com/gr/assets/js/gr-widget-sdk.js?v=3.4.1';
        public static $_plugin_version  = '3.4.1';

        /**
         * Construct the plugin object
         */
        public function __construct()
        {
            // register actions
            add_action('admin_init', array(&$this, 'admin_init'));
            add_action('admin_menu', array(&$this, 'add_menu'));
            add_action( 'wp_footer', array( &$this,'gr_widget') );
            add_action('admin_enqueue_scripts', array(&$this,'google_font_styles'));
            // register actions for Blog Comments
            add_action('plugins_loaded', array( &$this, 'commenthook_init' ), 1);

            add_action('rest_api_init', array($this, 'register_rest_routes'), 10);

            //Install tab embed page changes
            add_action('save_post', array(&$this,'gr_save_post'), 10, 3);
            add_action('before_delete_post', array(&$this,'gr_delete_post'), 10, 3);
        } // END public function __construct

        /**
         * Activate the plugin
         */
        public static function activate()
        {
            if(class_exists('GR_Connect')){
                if ( is_plugin_active( plugin_basename( __FILE__ ) ) )
                    deactivate_plugins( plugin_basename( __FILE__ ) );

                wp_die( __( 'A Gratisfaction plugin is already running on your website. Only one installation can be active at any one time. If you want to install this version of Gratisfaction, then first deactivate the current Gratisfaction plugin.') );
            }
            if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
                if ( is_plugin_active( plugin_basename( __FILE__ ) ) )
                    deactivate_plugins( plugin_basename( __FILE__ ) );

                wp_die( __( 'As your website is using WooCommerce, you should install the Gratisfaction WooCommerce plugin.You can find this plugin in the Wordpress directory:  https://wordpress.org/plugins/gratisfaction-all-in-one-loyalty-contests-referral-program-for-woocommerce/') );
            }

            // Do nothing
            update_option( 'grappsmav_register', 2 );
        } // END public static function activate

        /**
         * Deactivate the plugin
         */
        public static function deactivate()
        {
            // Blog Comments
            remove_action('comment_post', array('GR_Appsmav','send_comment_to_appsmav'));
            remove_action('init', array('GR_Appsmav', 'init_page_load'));

            // Deactivate shop
            $id_shop = get_option('grappsmav_shop_id', 0);
            $id_site = get_option('grappsmav_appid', 0);
            $payload = get_option('grappsmav_payload', 0 );
            $param = array('app'=>'gr', 'plugin_type'=>'WP_plain', 'status'=>'deactivate', 'id_shop'=>$id_shop, 'id_site'=>$id_site, 'payload'=>$payload);
            $url = self::$_callback_url.self::$_api_version.'pluginStatus';

            wp_remote_post($url, array('body' => $param, 'timeout' => 10));

        } // END public static function deactivate

        /**
         * hook into WP's admin_init action hook
         */
        public function admin_init()
        {
            // Set up the settings for this plugin
            $this->init_settings();
            // Possibly do additional admin_init tasks
        } // END public static function activate

        /**
         * Initialize some custom settings
         */
        public function init_settings()
        {
            // register the settings for this plugin
            add_action( 'wp_ajax_create_gr_account', array(&$this,'gr_ajax_create_gr_account' ));
            add_action( 'wp_ajax_check_gr_settings', array(&$this,'gr_ajax_check_gr_settings' ));
            add_action( 'wp_ajax_check_login', array(&$this,'gr_ajax_check_login' ));

        } // END public function init_custom_settings()


        function gr_widget()
        {
            $app_id = get_option('grappsmav_appid', 0);

            if(empty($app_id))
                return false;


            $id_site        = get_option('grappsmav_appid');
            $arr['id_site'] = $id_site;
            $arr['error']   = 0;
            $cid            =	$cemail   =	$cname  = $first_name = $last_name =   '';

            if ( is_user_logged_in() ) {
                $current_user = wp_get_current_user();
                $cid    = $current_user->ID;
                $cemail = $current_user->user_email;
                $cname      =	$current_user->display_name;
                $first_name = $current_user->user_firstname;
                $last_name = $current_user->user_lastname;
            }

            echo '<script>var AMGRConfig = {user : {name : "'.$cname.'", first_name : "'.$first_name.'", last_name : "'.$last_name.'", email : "'.$cemail.'", id : "'.$cid.'", country : ""}, site : {id : "'.$id_site.'", domain : "'.get_option('siteurl').'", platform : "WP_plain"}};
            (function(d, s, id) {
                var js, amjs = d.getElementsByTagName(s)[0];
                if (d.getElementById(id)) return;
                js = d.createElement(s); js.id = id; js.async = true;
                js.src = "'.self::$_c_sdk_url.'";
                amjs.parentNode.insertBefore(js, amjs);
            }(document, "script", "gratisfaction-sdk"));
            </script>';
        }

        public static function gr_wp_app_show_func($atts) {
            $id = isset($atts['id']) ? trim($atts['id']) : '';

            if (empty($id))
                return '';

            $url = self::$_callback_url . 'promo/' . $id;
            if (isset($atts['rtype']) && $atts['rtype'] == 'link') {
                $content = '<a class="gr-widget ec-widget" href="' . $url . '" >Rewards</a>';
                $js_url = self::$_callback_url . 'script.js';

                wp_enqueue_script('gratisfaction_frame_script', $js_url, array(), '3.3.7', true);
            } else {
                $content = '<div class="GREmbedContainer"><iframe data-grclass="gr_iframe_widget" class="gr_iframe_widget" vspace="0" hspace="0" width="100%" height="400px" src="' . $url . '" frameborder="0" allow="clipboard-read; clipboard-write">Rewards</iframe></div>
                    <script>
                        try{if("URLSearchParams"in window){var mavtoken,params={},searchParams=new URLSearchParams(window.location.search);searchParams.has("id_ref")?(params.id_ref=searchParams.get("id_ref"),searchParams.has("mavtoken")&&(params.mavtoken=searchParams.get("mavtoken"))):"undefined"==typeof Storage||void 0!==(mavtoken=localStorage.GRmavtoken)&&""!=mavtoken&&null!=mavtoken&&"null"!=mavtoken&&"NULL"!=mavtoken&&(params.mavtoken=mavtoken);for(var app_url,elems=document.querySelectorAll("[data-grclass]"),sParams=new URLSearchParams(params),i=0;i<elems.length;i++)elems[i].id="ec_iframe_"+i,0<Object.keys(params).length&&(app_url=elems[i].src,app_url+=(-1==app_url.indexOf("?")?"?":"&")+sParams,elems[i].src=app_url),void 0!==elems[i].className&&""!=elems[i].className||(elems[i].className="gr_iframe_widget")}}catch(a){}
                    </script>';
            }

            return $content;
        }

        /**
         * add a menu
         */
        public function add_menu()
        {
            add_options_page('GR Appsmav Settings', 'Gratisfaction', 'manage_options', 'grappsmav', array(&$this, 'plugin_settings_page'));
        } // END public function add_menu()


        public function google_font_styles($hook) {
            if('settings_page_grappsmav' != $hook)
                return;

            // register styles
            wp_register_style( 'bootstrap_css', plugins_url('/css/bootstrap-3.2.0.min.css', __FILE__) );
            wp_register_style( 'gr_appsmav_css', plugins_url('/css/grappsmav.css', __FILE__) );

            // enqueue styles
            wp_enqueue_style('bootstrap_css');
            wp_enqueue_style('gr_appsmav_css');

            // enqueue scripts
            wp_enqueue_script( 'bootstrap_script', plugins_url( '/js/bootstrap.min.js',__FILE__ ),array(), '1.0.1', true );
            wp_enqueue_script( 'jquery_validity_script', plugins_url( '/js/jquery.validity.js',__FILE__ ),array(), '1.0.1', true );
            wp_enqueue_script( 'gr_appsmav_script', plugins_url( '/js/grappsmav.js',__FILE__ ),array(), '1.0.1', true );

        }

        /**
         * Menu Callback
         */
        public function plugin_settings_page()
        {
            if (!current_user_can('manage_options'))
                wp_die(__('You do not have sufficient permissions to access this page.'));

            // Render the settings template
            $frame_url	= 'about:blank';
            if(get_option('grappsmav_register', 0 )	== 1){
                $arr['id_shop']     = get_option('grappsmav_shop_id', 0 );
                $arr['admin_email'] = get_option('grappsmav_admin_email');
                $arr['payload']     = get_option('grappsmav_payload', 0 );

                $frame_url = self::$_callback_url.'autologin?id_shop='.$arr['id_shop'].'&admin_email='.urlencode($arr['admin_email']).'&payload='.$arr['payload'].'&type=plain';
            }
            include(sprintf("%s/templates/settings.php", dirname(__FILE__)));

        } // END public function plugin_settings_page()

        public function gr_ajax_check_gr_settings()
        {
            $raffd = isset($_POST['raffd']) ? sanitize_text_field($_POST['raffd']) : '';
            $email = get_option('grappsmav_admin_email');
            if(isset($_POST['admin_email']))
                $email = sanitize_email($_POST['admin_email']);

            $param['email']    = $email;
            $param['raffd']    = $raffd;
            $param['shop_url'] = get_option('siteurl');
            $param["app"]      = 'gr';
            $param["action"]   = "verifyShopExists";
            $param['payload']  = get_option('grappsmav_payload', 0);
            $param['plugin_type']   = 'WP_plain';
            $param['campaign_only'] = 2;
            $param['plugin_version']= "3.3.7";

            $res = array();
            $response = wp_remote_post(self::$_api_url, array('body' => $param, 'timeout' => 10));
            if(is_array($response) && !empty($response['body']))
                $res = json_decode($response['body'], true);

            if( !empty($res['is_shop']) && $res['is_shop'] == 1)
            {
                update_option( 'grappsmav_admin_email', $email);
                update_option( 'grappsmav_shop_id', $res['id_shop']);
                update_option( 'grappsmav_appid', $res['id_site']);
                update_option( 'grappsmav_payload', $res['pay_load']);
                update_option( 'grappsmav_register', 1 );

                $res['gr_reg']    = 0;
                $res['frame_url'] = self::$_callback_url.'autologin?id_shop='.$res['id_shop'].'&admin_email='.urlencode($email).'&payload='.$res['pay_load'].'&cur='.get_option('woocommerce_currency','USD');

                // Update WP plugin status
                $param = array('app'=>'gr', 'plugin_type'=>'WP_plain', 'status'=>'activate', 'id_shop'=>$res['id_shop'], 'id_site'=>$res['id_site'], 'payload'=>$res['pay_load']);
                $urlPluginStatus = self::$_callback_url.self::$_api_version.'pluginStatus';

                wp_remote_post($urlPluginStatus, array('body' => $param, 'timeout' => 10));

            }
            else if (!empty($res['is_shop']) && $res['is_shop'] == 2)
            {
                $ip_info = self::_getIPDetails();
                $current_user = wp_get_current_user();

                $params	= array();
                $params["action"] = "createaccount";

                $params["firstname"]    = $current_user->user_firstname;
                $params["lastname"]     = $current_user->user_lastname;
                $params["companyname"]	= get_bloginfo('name');
                $params["companyname"]	= !empty($params["companyname"])?get_bloginfo('name'):'Your Business name';

                $params["address1"]     = '***'; //Dummy
                $params["city"]         = empty($ip_info['city']) ? '***' : $ip_info['city'];
                $params["state"]        = empty($ip_info['region_name']) ? '***' : $ip_info['region_name'];
                $params["postcode"]     = '1'; //Dummy;
                $params["country"]      = empty($ip_info["country_code"]) ? 'US' : $ip_info["country_code"];

                $params["currency"] 	= ($params["country"] === 'AU')? 3:1;
                $params["phonenumber"] 	= '1234567890';//Dummy

                $params["notes"]        = 'Wordpress plain';
                $params["app"]          = 'gr';
                $params['email']        = $email;
                $params['raffd']        = $raffd;
                $params['url']          = get_option('siteurl');
                $params["name"]         = $params["companyname"];
                $params['type']         = 'url';
                $params['plugin_type']  = 'WP_plain';
                $params['shop_url']     = get_option('siteurl');
                $params['shop_name']    = $params["companyname"];

                $params['campaign_name']= "REWARDS";
                $params['timezone']     = 'America/Chicago';//Dummy $p['grappsmav_reg_timezone'];
                $params['date_format']  = 'd/m/Y';//Dummy$p['grappsmav_reg_date_format'];
                $params['exclusion_period'] = 0;
                $params['campaign_only']    = 2;

                $params['login_url']        = get_option('siteurl');
                $params['payload']          = get_option('grappsmav_payload', 0);
                $params['plugin_version']   = "3.3.7";
                $params['users_can_register']   = get_option('users_can_register', 0);
                $params['wp_login_url']   = wp_login_url();
                $params['wp_registration_url']   = wp_registration_url();

                $res = array();
                $response = wp_remote_post(self::$_api_url, array('body' => $params, 'timeout' => 10));
                if(is_array($response) && !empty($response['body']))
                    $res = json_decode($response['body'], true);

                if ($res['error'] == 0)
                {
                    $res['gr_reg'] = 0;
                    update_option( 'grappsmav_shop_id', $res['id_shop']);
                    update_option( 'grappsmav_appid', $res['id_site']);
                    update_option( 'grappsmav_payload', $res['pay_load']);
                    update_option( 'grappsmav_admin_email', $email);
                    update_option( 'grappsmav_register', 1 );
                    $res['frame_url'] = self::$_callback_url.'autologin?id_shop='.$res['id_shop'].'&admin_email='.urlencode($email).'&payload='.$res['pay_load'].'&type=plain';
                }
                else if ($res['error'] == 1)
                    $res['gr_reg'] = 1;
                else if ($res['error'] == 2 || $res['error'] == 3)
                {
                    update_option( 'grappsmav_register', 3 );
                    $res['gr_reg'] = 2;
                }
                else
                    $res['gr_reg'] = 4;
            }
            else
            {
                $res['gr_reg'] = 1;
            }

            die(json_encode($res));
        }

        public function gr_ajax_check_login()
        {
            try
            {
                if(empty($_POST['grappsmav_login_email']) || !filter_var($_POST['grappsmav_login_email'], FILTER_VALIDATE_EMAIL))
                    die("Please enter valid email");

                if(empty($_POST['grappsmav_login_pwd']))
                    die("Please enter password");

                $res = array();
                $params = array();
                $email                 = sanitize_email($_POST['grappsmav_login_email']);
                $adminEmailTemp        = get_option('grappsmav_admin_email');
                $adminEmail            = empty($adminEmailTemp) ? $email : $adminEmailTemp;
                $params["action"]      = 'login';
                $params["app"]         = 'gr';
                $params['email']       = $email;
                $params['admin_email'] = $adminEmail;
                $params['password']    = sanitize_text_field( $_POST['grappsmav_login_pwd'] );
                $params['shop_url']    = get_option('siteurl');

                $resCurl = array();
                $response = wp_remote_post(self::$_api_url, array('body' => $params, 'timeout' => 10));
                if(is_array($response) && !empty($response['body']))
                    $resCurl = json_decode($response['body'], true);

                if ($resCurl['error'] == 0)
                {
                    update_option( 'grappsmav_admin_email', $adminEmail);
                    update_option( 'grappsmav_shop_id', $resCurl['id_shop']);
                    update_option( 'grappsmav_appid', $resCurl['id_site']);
                    update_option( 'grappsmav_payload', $resCurl['pay_load']);
                    update_option( 'grappsmav_register', 1 );

                    $res['error']     = 0;
                    $res['frame_url'] = self::$_callback_url.'autologin?id_shop='.$resCurl['id_shop'].'&admin_email='.urlencode($adminEmail).'&payload='.$resCurl['pay_load'].'&cur='.get_option('woocommerce_currency','USD');

                    // Update WP plugin status
                    $param = array('app'=>'gr', 'plugin_type'=>'WP_plain', 'status'=>'activate', 'id_shop'=>$resCurl['id_shop'], 'id_site'=>$resCurl['id_site'], 'payload'=>$resCurl['pay_load']);
                    $urlPluginStatus = self::$_callback_url.self::$_api_version.'pluginStatus';

                    wp_remote_post($urlPluginStatus, array('body' => $param, 'timeout' => 10));
                }
                else
                {
                    $res['error']   = 1;
                    $res['message'] = (!empty($resCurl['message'])) ? $resCurl['message'] : "Invalid Email / Password";
                }

            }
            catch (Exception $ex)
            {
                $res['error'] = 1;
                $res['message'] = $ex->getMessage();
            }

            die(json_encode($res));
        }

        public function gr_ajax_create_gr_account(){
            self::callAcctRegister($_POST);
        }

        protected static function _getIPDetails()
        {
            // Default return value for failure case of API request
            $ip_details = array('ip'=>$ip, 'city'=>'', 'region_name'=>'', 'country_code'=>'US');

            try {
                $ip  = $_SERVER['REMOTE_ADDR'];
                $url = 'http://www.geoplugin.net/json.gp?ip='.$ip;
                $response = wp_remote_get( $url );

                if (is_array($response) && !empty($response['body']))
                {
                    $ipLocArr = json_decode($response['body'], TRUE);
                    if ($ipLocArr['geoplugin_request'] == $ip && $ipLocArr['geoplugin_status'] == 200) {
                        $ip_details['ip']            = empty($ipLocArr['geoplugin_request']) ? $ip : $ipLocArr['geoplugin_request'];
                        $ip_details['city']          = empty($ipLocArr['geoplugin_city']) ? null : $ipLocArr['geoplugin_city'];
                        $ip_details['region_name']   = empty($ipLocArr['geoplugin_regionName']) ? null : $ipLocArr['geoplugin_regionName'];
                        $ip_details['country_code']  = empty($ipLocArr['geoplugin_countryCode']) ? 'US' : $ipLocArr['geoplugin_countryCode'];
                    }
                }

            } catch (Exception $e) { }

            return $ip_details;
        }

        private function callAcctRegister($p)
        {
            if (empty($p['grappsmav_reg_email_user']))
            {
                $resArr = array('gr_reg'=>4, 'message'=>'Enter valid email address');
                die(json_encode($resArr));
            }

            $ip_info                = self::_getIPDetails();
            $params["action"]       = "createaccount";
            $params["firstname"]    = sanitize_text_field( $p['grappsmav_reg_firstname']);
            $params["lastname"]     = sanitize_text_field( $p['grappsmav_reg_lastname']);
            $params["raffd"]        = sanitize_text_field( $p['raffd']);
            $params["companyname"]  = get_bloginfo('name');
            $params["companyname"]  = !empty($params["companyname"])?get_bloginfo('name'):'Your Business name';
            $params["email"]        = sanitize_email($p['grappsmav_reg_email_user']);
            $params["email_user"]   = sanitize_email($p['grappsmav_reg_email_user']);
            $params['address1']     = '***'; //Dummy
            $params['city']         = empty($ip_info['city']) ? '***' : $ip_info['city'];
            $params['state']        = empty($ip_info['region_name']) ? '***' : $ip_info['region_name'];
            $params['postcode']     = '1'; //Dummy
            $params['country']      = empty($ip_info["country_code"]) ? 'US' : $ip_info["country_code"];
            $params['currency']     = ($params['country'] === 'AU')? 3:1;
            $params['phonenumber']  = '1234567890';//Dummy
            $params["notes"]        = 'Wordpress plain';
            $params["app"]          = 'gr';
            $params['url']          = get_option('siteurl');
            $params["name"]         = $params["companyname"];
            $params['type']         = 'url';
            $params['plugin_type']  = 'WP_plain';
            $params['shop_url']     = get_option('siteurl');
            $params['shop_name']    = $params["companyname"];

            $params['campaign_name']    = "REWARDS";
            $params['timezone']         = 'America/Chicago';//Dummy $p['grappsmav_reg_timezone'];
            $params['date_format']      = 'd/m/Y';//Dummy$p['grappsmav_reg_date_format'];
            $params['exclusion_period'] = 0;//$p['grconnect_reg_exclusion_period'];
            $params['campaign_only']    = 2;

            $params['login_url']        = get_option('siteurl');
            $params['plugin_version']   = "3.3.7";
            $params['users_can_register']   = get_option('users_can_register', 0);
            $params['wp_login_url']   = wp_login_url();
            $params['wp_registration_url']   = wp_registration_url();

            $resArr = array();
            $response = wp_remote_post(self::$_api_url, array('body' => $params, 'timeout' => 10));

            if(is_array($response) && !empty($response['body']))
                $resArr = json_decode($response['body'], true);

            if (isset($resArr['error']) && $resArr['error'] == 0)
            {
                update_option( 'grappsmav_shop_id', $resArr['id_shop']);
                update_option( 'grappsmav_admin_email', $params['email']);
                update_option( 'grappsmav_appid', $resArr['id_site']);
                update_option( 'grappsmav_payload', $resArr['pay_load']);
                update_option( 'grappsmav_register', 1 );
                $resArr['frame_url'] = self::$_callback_url.'autologin?id_shop='.$resArr['id_shop'].'&admin_email='.urlencode($params["email"]).'&payload='.$resArr['pay_load'].'&type=plain';
                $resArr['gr_reg']    = 0;
            }
            else if (isset($resArr['error']) && $resArr['error'] == 1)
            {
                $resArr['gr_reg'] = 1;
            }
            else if (isset($resArr['error']) && $resArr['error'] == 2)
            {
                update_option( 'grappsmav_register', 3 );
                $resArr['gr_reg'] = 2;
            }
            else
            {
                $resArr['gr_reg'] = 4;
            }

            die(json_encode($resArr));
        }

        public function init_page_load()
        {
            if(isset($_REQUEST['grc']))
            {
                if( !session_id())
                   session_start();

               $_SESSION['grc']     = sanitize_text_field($_REQUEST['grc']);
               $_SESSION['gre']     = sanitize_text_field($_REQUEST['gre']);
               $_SESSION['typ']     = isset($_REQUEST['type']) ? sanitize_text_field($_REQUEST['type']) : 'gr';
               $_SESSION['scopeid'] = sanitize_text_field($_REQUEST['scopeid']);
            }

        }
        /**
         * hook into WP's woocommerce payment made action hook
         */
        public function send_comment_to_appsmav($comment_ID)
        {
            if( !session_id())
                session_start();

            if(isset($_SESSION['grc'])){
                switch($_SESSION['typ'])
                {
                    case 'sb':
                        $params	= '?grc='.$_SESSION['grc'].'&gre='.$_SESSION['gre'].'&scopeid='.$_SESSION['scopeid'].'&cid='.$comment_ID;
                        wp_redirect(self::$_callback_url . 'contest/play/'.$_SESSION['grc'].'/'.$params);
                        exit();
                    default:
                        $params	= '?grc='.$_SESSION['grc'].'&gre='.$_SESSION['gre'].'&scopeid='.$_SESSION['scopeid'].'&cid='.$comment_ID;
                        wp_redirect(self::$_callback_url . 'contest/play/'.$_SESSION['grc'].'/'.$params);
                        exit();
                }

            }
        }

        /**
         * hook into WP's admin_init action hook
         */
        public function commenthook_init()
        {
            // Set up the settings for this plugin
            add_action('comment_post', array(&$this, 'send_comment_to_appsmav'));
            add_action('wp', array(&$this, 'init_page_load'));

            // Possibly do additional admin_init tasks
        } // END public static function activate

        function gr_save_post($post_id, $post, $update)
        {
            try
            {
                // Only want to set if this is a old post!
                if (!$update || 'page' !== $post->post_type) {
                    return;
                }

                $is_embed_landing_url = get_post_meta($post->ID, 'is_embed_landing_url', true);
                if ($is_embed_landing_url != 1) {
                    return;
                }

                $url     = self::$_callback_url . self::$_api_version . 'wooInstallTabChange';
                $app_id  = get_option('grappsmav_appid');
                $payload = get_option('grappsmav_payload', 0);

                if(empty($app_id) || empty($payload)) {
                    throw new Exception('IntegrationMissing');
                }

                $param = array(
                    'id_site'   => $app_id,
                    'payload'   => $payload,
                    'id'        => $post->ID,
                    'title'     => $post->post_title,
                    'url'       => get_permalink($post->ID),
                    'publish'   => $post->post_status == 'publish' ? 1 : 0,
                    'is_embed_landing_url' => $is_embed_landing_url
                );

                $res = self::_curlResp($param, $url);
                if(empty($res) || $res['error'] == 1) {
                    throw new Exception('VerificationFailed');
                }
            }
            catch (Exception $ex)
            {
                $resp['error'] = 1;
                $resp['msg']   = $ex->getMessage();
            }
        }

        function gr_delete_post($post_id)
        {
            try
            {
                $post = get_post($post_id);
                if ('page' !== $post->post_type) {
                    return;
                }

                $is_embed_landing_url = get_post_meta($post_id, 'is_embed_landing_url', true);
                if ($is_embed_landing_url != 1) {
                    return;
                }

                $url     = self::$_callback_url . self::$_api_version . 'wooInstallTabDelete';
                $app_id  = get_option('grappsmav_appid');
                $payload = get_option('grappsmav_payload', 0);

                if(empty($app_id) || empty($payload)) {
                    throw new Exception('IntegrationMissing');
                }

                update_post_meta($post_id, 'is_embed_landing_url', 0);

                $param = array(
                    'id_site' => $app_id,
                    'payload' => $payload,
                    'id'      => $post_id
                );

                $res = self::_curlResp($param, $url);
                if(empty($res) || $res['error'] == 1)
                    throw new Exception('VerificationFailed');
            }
            catch (Exception $ex)
            {
                $resp['error'] = 1;
                $resp['msg']   = $ex->getMessage();
            }
        }

        protected static function _curlResp($param,$url)
        {
            $response = wp_remote_post($url,array('body'=> $param,'timeout' => 10));
            if (is_array($response) && !empty($response['body'])) {
               $resp = json_decode($response['body'], true);
            } else {
               $resp['error']  = 1;
            }

            return $resp;
        }

        public function include_files()
        {
            try
            {
                include(sprintf("%s/includes/grwp-api.php", GR_WP_PLUGIN_BASE_PATH));
            } catch (Exception $ex) {
            }
        }

        public function register_rest_routes()
        {
            try {
                $route = new Grwp_API();
                $route->register_apis();
            } catch (Exception $ex) {

            }
        }

    } // END class GR_Connect
} // END if(!class_exists('GR_Connect'))


if(class_exists('GR_Appsmav'))
{
    // Installation and uninstallation hooks
    register_activation_hook(__FILE__, array('GR_Appsmav', 'activate'));
    register_deactivation_hook(__FILE__, array('GR_Appsmav', 'deactivate'));

    // instantiate the plugin class
    $gr_appsmav = new GR_Appsmav();

	// Add the settings link to the plugins page
    function plugin_settings_gr_link($links)
    {
        $settings_link = '<a href="options-general.php?page=grappsmav">Settings</a>';
        array_unshift($links, $settings_link);
        return $links;
    }

    $gr_appsmav->include_files();

    $plugin = plugin_basename(__FILE__);
    add_filter("plugin_action_links_$plugin", 'plugin_settings_gr_link');
	add_shortcode('gr-campaign', array( 'GR_Appsmav', 'gr_wp_app_show_func' ) );
}
